#include	<stdio.h>
#include	<math.h>

main()
{
int		i,j,k,fval,x_pt,y_pt,askii,div_mod,exp,inc,bin,mult;
float		fsmp,fwv[10],csum,rad;
float		t,t_smp,t_max,nsmp,y_ptf;

FILE	*fp;
FILE	*fq;

fp = fopen("input.dat","w");
fq = fopen("param.dat","w");

printf("Digital Waveform Sampler And Data Generator\n\n");
printf("Generates A Composite Waveform From Up To\n");
printf("Ten Cosine Waves Of Equal Amplitude\n\n");
printf("Data File input.dat Contains 16-Bit Samples\n");
printf("Data File param.dat Contains signal paramemters\n");
printf("Please enter the sampling frequency\n");
printf("Assume All Frequencies Are In Hertz\n");
scanf("%f",&fsmp);
fprintf(fq,"Sampling Frequency = %6.0f Hertz\n",fsmp);

printf("Please enter the number of waves to be sampled\n");
printf("Maximum Number Of Waves Is 10\n");
scanf("%d",&j);

for(i=1;i<=j;i++)	{
	printf("Please enter the frequency for wave %d\n",i);
	scanf("%f",&fwv[i]);
	fprintf(fq,"Frequency of Wave %d = %6.0f Hertz\n",i,fwv[i]);					}


printf("%Please enter the number of samples\n");
scanf("%f",&nsmp);
fprintf(fq,"Number of samples = %4.0f\n",nsmp);

printf("Please enter the number of guard bits\n");
scanf("%d",&exp);
fprintf(fq,"Guard bits = %d\n",exp);

printf("Output data file in hex or binary? (0 for binary, 1 for hex)\n");
scanf("%d",&bin);

div_mod=1;
if(exp>0)			{
for(i=1;i<=exp;i++)
	div_mod=div_mod*2;	}

t_max=(nsmp-1)/fsmp;
t_smp=1/fsmp;
x_pt=0;

/* first create data file */

for(t=0;t<(t_max+t_smp);t=t+t_smp)  {
	csum=0;
	for(i=1;i<=j;i++)  {
		rad = 3.14159*2*fwv[i]*t;
		csum = csum + cos(rad);  }
	csum=csum*32768/(j*div_mod);
	if(csum>32767.0) csum=32767.0;
	fval=csum;
	if(bin==1)   fprintf(fp,"%04X\n",fval);
	if(bin==0)   {
		if(fval>=0)	fprintf(fp,"0");
		if(fval<0) {
			fprintf(fp,"1");
			fval=fval+32768;  }
		mult=16384;
		for(k=1;k<=15;k++)  {
			if(fval<mult)	fprintf(fp,"0");
			if(fval>=mult) 	{
				fprintf(fp,"1");
				fval=fval-mult; }
			mult=mult/2;}
		fprintf(fp,"\n");      }
			}

fclose(fq);
fclose(fp);

}
